[PATCH] cli: add a tool for starting new message in the emacs ui
authorDavid Bremner <david@tethera.net>
Tue, 1 Jul 2014 20:02:37 +0000 (17:02 +2100)
committerW. Trevor King <wking@tremily.us>
Fri, 7 Nov 2014 18:03:21 +0000 (10:03 -0800)
fe/dd9037d0961e4adf2ef0d41c89d5988fdcd287 [new file with mode: 0644]

diff --git a/fe/dd9037d0961e4adf2ef0d41c89d5988fdcd287 b/fe/dd9037d0961e4adf2ef0d41c89d5988fdcd287
new file mode 100644 (file)
index 0000000..afb4696
--- /dev/null
@@ -0,0 +1,274 @@
+Return-Path: <bremner@tesseract.cs.unb.ca>\r
+X-Original-To: notmuch@notmuchmail.org\r
+Delivered-To: notmuch@notmuchmail.org\r
+Received: from localhost (localhost [127.0.0.1])\r
+       by olra.theworths.org (Postfix) with ESMTP id 19486431FC4\r
+       for <notmuch@notmuchmail.org>; Tue,  1 Jul 2014 13:04:57 -0700 (PDT)\r
+X-Virus-Scanned: Debian amavisd-new at olra.theworths.org\r
+X-Spam-Flag: NO\r
+X-Spam-Score: 0\r
+X-Spam-Level: \r
+X-Spam-Status: No, score=0 tagged_above=-999 required=5 tests=[none]\r
+       autolearn=disabled\r
+Received: from olra.theworths.org ([127.0.0.1])\r
+       by localhost (olra.theworths.org [127.0.0.1]) (amavisd-new, port 10024)\r
+       with ESMTP id vnWCwVI8Opbv for <notmuch@notmuchmail.org>;\r
+       Tue,  1 Jul 2014 13:04:49 -0700 (PDT)\r
+Received: from mx.xen14.node3324.gplhost.com (gitolite.debian.net\r
+       [87.98.215.224]) (using TLSv1 with cipher AES256-SHA (256/256 bits))\r
+       (No client certificate requested)\r
+       by olra.theworths.org (Postfix) with ESMTPS id CF465431FBC\r
+       for <notmuch@notmuchmail.org>; Tue,  1 Jul 2014 13:04:48 -0700 (PDT)\r
+Received: from remotemail by mx.xen14.node3324.gplhost.com with local (Exim\r
+       4.72) (envelope-from <bremner@tesseract.cs.unb.ca>)\r
+       id 1X24Gp-0006a7-Dn; Tue, 01 Jul 2014 20:03:15 +0000\r
+Received: (nullmailer pid 3853 invoked by uid 1000); Tue, 01 Jul 2014\r
+       20:02:56 -0000\r
+From: David Bremner <david@tethera.net>\r
+To: notmuch@notmuchmail.org\r
+Subject: [PATCH] cli: add a tool for starting new message in the emacs ui\r
+Date: Tue,  1 Jul 2014 17:02:37 -0300\r
+Message-Id: <1404244957-3671-1-git-send-email-david@tethera.net>\r
+X-Mailer: git-send-email 2.0.0.rc2\r
+In-Reply-To: <1396799003-14855-1-git-send-email-jani@nikula.org>\r
+References: <1396799003-14855-1-git-send-email-jani@nikula.org>\r
+MIME-Version: 1.0\r
+Content-Type: text/plain; charset=UTF-8\r
+Content-Transfer-Encoding: 8bit\r
+X-BeenThere: notmuch@notmuchmail.org\r
+X-Mailman-Version: 2.1.13\r
+Precedence: list\r
+List-Id: "Use and development of the notmuch mail system."\r
+       <notmuch.notmuchmail.org>\r
+List-Unsubscribe: <http://notmuchmail.org/mailman/options/notmuch>,\r
+       <mailto:notmuch-request@notmuchmail.org?subject=unsubscribe>\r
+List-Archive: <http://notmuchmail.org/pipermail/notmuch>\r
+List-Post: <mailto:notmuch@notmuchmail.org>\r
+List-Help: <mailto:notmuch-request@notmuchmail.org?subject=help>\r
+List-Subscribe: <http://notmuchmail.org/mailman/listinfo/notmuch>,\r
+       <mailto:notmuch-request@notmuchmail.org?subject=subscribe>\r
+X-List-Received-Date: Tue, 01 Jul 2014 20:04:57 -0000\r
+\r
+From: Jani Nikula <jani@nikula.org>\r
+\r
+Add a tool to start composing an email in the Notmuch Emacs UI with\r
+the specified subject, recipients, and message body.\r
+---\r
+\r
+I added the necessary lines to conf.py to get the man pages built and installed\r
+\r
+I'd be happier with this if it could start emacs. I tried adding "-a\r
+''" to the emacsclient invokation, but that doesn't quite work; the\r
+message-mode buffer is created in emacs but no frame is displayed. It\r
+could be a peculiarity of my emacs setup, of course.\r
+\r
+\r
+ doc/conf.py                    |   4 ++\r
+ doc/man1/notmuch-emacs-mua.rst |  50 +++++++++++++++++\r
+ notmuch-emacs-mua              | 122 +++++++++++++++++++++++++++++++++++++++++\r
+ 3 files changed, 176 insertions(+)\r
+ create mode 100644 doc/man1/notmuch-emacs-mua.rst\r
+ create mode 100755 notmuch-emacs-mua\r
+\r
+diff --git a/doc/conf.py b/doc/conf.py\r
+index 70ba1b8..8ee19f4 100644\r
+--- a/doc/conf.py\r
++++ b/doc/conf.py\r
+@@ -74,6 +74,10 @@ man_pages = [\r
+         u'creates a plain-text dump of the tags of each message',\r
+         [u'Carl Worth and many others'], 1),\r
\r
++('man1/notmuch-emacs-mua','notmuch-emacs-mua',\r
++        u'send mail with notmuch and emacs',\r
++        [u'Carl Worth and many others'], 1),\r
++\r
+ ('man5/notmuch-hooks','notmuch-hooks',\r
+         u'hooks for notmuch',\r
+         [u'Carl Worth and many others'], 5),\r
+diff --git a/doc/man1/notmuch-emacs-mua.rst b/doc/man1/notmuch-emacs-mua.rst\r
+new file mode 100644\r
+index 0000000..6e63818\r
+--- /dev/null\r
++++ b/doc/man1/notmuch-emacs-mua.rst\r
+@@ -0,0 +1,50 @@\r
++=================\r
++notmuch-emacs-mua\r
++=================\r
++\r
++SYNOPSIS\r
++========\r
++\r
++**notmuch-emacs-mua** [options ...] [<to-address> ...]\r
++\r
++DESCRIPTION\r
++===========\r
++\r
++Start composing an email in the Notmuch Emacs UI with the specified\r
++subject, recipients, and message body.\r
++\r
++For **notmuch-emacs-mua** to work, you need **emacsclient** and an\r
++already running Emacs with a server.\r
++\r
++Supported options for **notmuch-emacs-mua** include\r
++\r
++    ``-h, --help``\r
++        Display help.\r
++\r
++    ``-s, --subject=``\ <subject>\r
++        Specify the subject of the message.\r
++\r
++    ``--to=``\ <to-address>\r
++        Specify a recipient (To).\r
++\r
++    ``-c, --cc=``\ <cc-address>\r
++        Specify a carbon-copy (Cc) recipient.\r
++\r
++    ``-b, --bcc=``\ <bcc-address>\r
++        Specify a blind-carbon-copy (Bcc) recipient.\r
++\r
++    ``-i, --body=``\ <file>\r
++        Specify a file to include into the body of the message.\r
++\r
++    ``--print``\r
++        Output the resulting elisp to stdout instead of evaluating it.\r
++\r
++The supported positional parameters and short options are a compatible\r
++subset of the **mutt** MUA command-line options.\r
++\r
++Options may be specified multiple times.\r
++\r
++SEE ALSO\r
++========\r
++\r
++**notmuch(1)**, **emacsclient(1)**, **mutt(1)**\r
+diff --git a/notmuch-emacs-mua b/notmuch-emacs-mua\r
+new file mode 100755\r
+index 0000000..7f94271\r
+--- /dev/null\r
++++ b/notmuch-emacs-mua\r
+@@ -0,0 +1,122 @@\r
++#!/usr/bin/env bash\r
++#\r
++# notmuch-emacs-mua - start composing a mail on the command line\r
++#\r
++# Copyright © 2014 Jani Nikula\r
++#\r
++# This program is free software: you can redistribute it and/or modify\r
++# it under the terms of the GNU General Public License as published by\r
++# the Free Software Foundation, either version 3 of the License, or\r
++# (at your option) any later version.\r
++#\r
++# This program is distributed in the hope that it will be useful,\r
++# but WITHOUT ANY WARRANTY; without even the implied warranty of\r
++# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\r
++# GNU General Public License for more details.\r
++#\r
++# You should have received a copy of the GNU General Public License\r
++# along with this program.  If not, see http://www.gnu.org/licenses/ .\r
++#\r
++# Authors: Jani Nikula <jani@nikula.org>\r
++#\r
++\r
++set -eu\r
++\r
++escape ()\r
++{\r
++    echo "${1//\"/\\\"}"\r
++}\r
++\r
++PRINT_ONLY=\r
++\r
++# The crux of it all: construct an elisp progn and eval it.\r
++ELISP="(progn (require 'notmuch) (notmuch-mua-new-mail)"\r
++\r
++while getopts :s:c:b:i:h opt; do\r
++    # Handle errors and long options.\r
++    case "${opt}" in\r
++      :)\r
++          echo "$0: short option -${OPTARG} requires an argument." >&2\r
++          exit 1\r
++          ;;\r
++      \?)\r
++          opt=$1\r
++          if [ "${OPTARG}" != "-" ]; then\r
++              echo "$0: unknown short option -${OPTARG}." >&2\r
++              exit 1\r
++          fi\r
++\r
++          case "${opt}" in\r
++              # Long options with arguments.\r
++              --subject=*|--to=*|--cc=*|--bcc=*|--body=*)\r
++                  OPTARG=${opt#--*=}\r
++                  opt=${opt%%=*}\r
++                  ;;\r
++              # Long options without arguments.\r
++              --help|--print)\r
++                  ;;\r
++              *)\r
++                  echo "$0: unknown long option ${opt}, or argument mismatch." >&2\r
++                  exit 1\r
++                  ;;\r
++          esac\r
++          # getopts does not do this for what it considers errors.\r
++          OPTIND=$((OPTIND + 1))\r
++          ;;\r
++    esac\r
++\r
++    OPTARG="$(escape "${OPTARG}")"\r
++\r
++    case "${opt}" in\r
++      --help|h)\r
++          exec man notmuch-emacs-mua\r
++          ;;\r
++      --subject|s)\r
++          ELISP="${ELISP} (message-goto-subject) (insert \"${OPTARG}\")"\r
++          ;;\r
++      --to)\r
++          ELISP="${ELISP} (message-goto-to) (insert \"${OPTARG}, \")"\r
++          ;;\r
++      --cc|c)\r
++          ELISP="${ELISP} (message-goto-cc) (insert \"${OPTARG}, \")"\r
++          ;;\r
++      --bcc|b)\r
++          ELISP="${ELISP} (message-goto-bcc) (insert \"${OPTARG}, \")"\r
++          ;;\r
++      --body|i)\r
++          ELISP="${ELISP} (message-goto-body) (cd \"${PWD}\") (insert-file \"${OPTARG}\")"\r
++          ;;\r
++      --print)\r
++          PRINT_ONLY=1\r
++          ;;\r
++      *)\r
++          # We should never end up here.\r
++          echo "$0: internal error (option ${opt})." >&2\r
++          exit 1\r
++          ;;\r
++    esac\r
++\r
++    shift $((OPTIND - 1))\r
++    OPTIND=1\r
++done\r
++\r
++# Positional parameters.\r
++for arg; do\r
++    arg="$(escape "${arg}")"\r
++    ELISP="${ELISP} (message-goto-to) (insert \"${arg}, \")"\r
++done\r
++\r
++# End progn.\r
++ELISP="${ELISP})"\r
++\r
++if [ -n "$PRINT_ONLY" ]; then\r
++    echo ${ELISP}\r
++    exit 0\r
++fi\r
++\r
++# Evaluate the progn.\r
++emacsclient --eval "${ELISP}" >/dev/null\r
++if [ $? -ne 0 ]; then\r
++    echo "$0: emacsclient failed" >&2\r
++    exit 1\r
++fi\r
+-- \r
+2.0.0.rc2\r
+\r